#pragma once

template<typename T>
class BinaryTree
{
public:
	//template<typename T>
	class Node
	{
	public:
		Node(T value):data(value), left(0), right(0){}
		T data;
		Node *left, *right;
	};

public:
	BinaryTree()
	{
		m_pRoot = NULL;
	}

	Node* root() { return m_pRoot; }
	void create(T* pData, T splite)
	{
		index = 0;
		create(pData, splite, &m_pRoot);
	}

	int depth()
	{
		return depth(m_pRoot);
	}

	/* : ǰݹT */
	void PreOrderTraverse(Node* node)
	{ 
		if(node==NULL)
			return;
		std::cout<<node->data;/* ʾݣԸΪԽ */
		PreOrderTraverse(node->left); /*  */
		PreOrderTraverse(node->right); /*  */
	}
	/* : ݹT */
	void InOrderTraverse(Node* node)
	{ 
		if(node==NULL)
			return;
		InOrderTraverse(node->left); /*  */
		std::cout<<node->data;/* ʾݣԸΪԽ */
		InOrderTraverse(node->right); /*  */
	}

	/* : ݹT */
	void PostOrderTraverse(Node* node)
	{
		if(node==NULL)
			return;
		PostOrderTraverse(node->left); /* Ⱥ  */
		PostOrderTraverse(node->right); /* ٺ  */
		std::cout<<node->data;/* ʾݣԸΪԽ */
	}
private:
	void create(T* pData, T splite,  Node **node)
	{
		if (pData == NULL) return;
		//T data = (*pData)++;
		T data = pData[index++];
		if (data == splite) return;
		*node = new Node(data);
		//std::cout<<data<<"\t";
		create(pData, splite, &(*node)->left);
		create(pData, splite, &(*node)->right);
	}
	int index;

	int depth(Node* node)
	{
		int i,j;
		if(!node)
			return 0;
		if(node->left)
			i=depth(node->left);
		else
			i=0;
		if(node->right)
			j=depth(node->right);
		else
			j=0;
		return i>j?i+1:j+1;
	}
	Node *m_pRoot;
};
